//----demo file for the using of CTEQPDF c++ inteface-----
#include <cstdlib>
#include <vector>
#include <string>
#include <iomanip>
#include <iostream>
#include <fstream>
#include <math.h>
#include <time.h>
#include <ct11pdf.h>
//-------------------------------------------------

using namespace std;
//-------------------------------------------------

int main() {

//---name of the CTEQ pds file------ 
  string it1="../pds/METAv10/METAv10.00.pds";
  string it2="../pds/METAv10/METAv10.01.pds";

//---define a PDF table-------
  cteqpdf meta1, meta2;

//---initializing the PDF table-----
  cout <<endl;
  cout <<endl;
  meta1.setct11(it1);
  meta2.setct11(it2);

//---get the parton distribution functions----
  double x=0.01, Q=91.187;
  double pg1, pg2;

  cout <<endl;
  cout <<endl;

  pg1=meta1.parton(0, x, Q);
  pg2=meta2.parton(0, x, Q);
  cout << "Gluon PDFs at Q="<<Q<<" and x="<<x <<endl;
  cout << "For "<<meta1.filepds<< " g="<<pg1<<endl;
  cout << "For "<<meta2.filepds<< " g="<<pg2<<endl;
  cout <<endl;

  pg1=meta1.parton(1, x, Q);
  pg2=meta2.parton(1, x, Q);
  cout << "u quark PDFs at Q="<<Q<<" and x="<<x <<endl;
  cout << "For "<<meta1.filepds<< " u="<<pg1<<endl;
  cout << "For "<<meta2.filepds<< " u="<<pg2<<endl;
  cout <<endl;

  pg1=meta1.parton(2, x, Q);
  pg2=meta2.parton(2, x, Q);
  cout << "d quark PDFs at Q="<<Q<<" and x="<<x <<endl;
  cout << "For "<<meta1.filepds<< " d="<<pg1<<endl;
  cout << "For "<<meta2.filepds<< " d="<<pg2<<endl;
  cout <<endl;

  pg1=meta1.parton(3, x, Q);
  pg2=meta2.parton(3, x, Q);
  cout << "s quark PDFs at Q="<<Q<<" and x="<<x <<endl;
  cout << "For "<<meta1.filepds<< " s="<<pg1<<endl;
  cout << "For "<<meta2.filepds<< " s="<<pg2<<endl;
  cout <<endl;

  pg1=meta1.parton(4, x, Q);
  pg2=meta2.parton(4, x, Q);
  cout << "c quark PDFs at Q="<<Q<<" and x="<<x <<endl;
  cout << "For "<<meta1.filepds<< " c="<<pg1<<endl;
  cout << "For "<<meta2.filepds<< " c="<<pg2<<endl;
  cout <<endl;

  pg1=meta1.parton(5, x, Q);
  pg2=meta2.parton(5, x, Q);
  cout << "b quark PDFs at Q="<<Q<<" and x="<<x <<endl;
  cout << "For "<<meta1.filepds<< " b="<<pg1<<endl;
  cout << "For "<<meta2.filepds<< " b="<<pg2<<endl;
  cout <<endl;

//---get the alphas value
  double al;
  al=meta1.alphas(Q);
  cout << "\n"<<"\n"<<"Alphas at Q="<<Q<<endl;
  cout << "For "<<meta1.filepds<< " as="<<al<<endl;

//---test of speed----
  time_t t1=time(0);
  for (int i=1; i<=201; i++) {
	  for (int j=1; j<=201; j++) {
		  x=exp(log(10.)*(-5.*(i-1)/200.));  
		  Q=exp(log(10.)*(4.*(j-1)/200.));
		  for (int k=-5; k<=5; k++) {
			  pg1=meta1.parton(k, x, Q);
		  }
	  }
  }
  time_t t2=time(0);
  double d=difftime(t2, t1);
  cout << "It took "<< d << " seconds"<<endl;


//---release the PDF tables
  cout <<endl;
  cout <<endl;
  meta1.pdfexit();
  meta2.pdfexit();

  return 0;
}

